#ifndef __STDCSN_H
#define __STDCSN_H
//
//  (C) Copyright 1993-2008 by Autodesk, Inc.  All rights reserved.
//
// Permission to use, copy, modify, and distribute this software in
// object code form for any purpose and without fee is hereby granted, 
// provided that the above copyright notice appears in all copies and 
// that both that copyright notice and the limited warranty and
// restricted rights notice below appear in all supporting 
// documentation.
//
// AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS. 
// AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF
// MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK, INC. 
// DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE
// UNINTERRUPTED OR ERROR FREE.
//
// Use, duplication, or disclosure by the U.S. Government is subject to 
// restrictions set forth in FAR 52.227-19 (Commercial Computer
// Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii)
// (Rights in Technical Data and Computer Software), as applicable.
//

#ifndef __STDISO_H
#error include 'stdISO.h' before including this file
#endif

class STDIMP_DLLSHARE AcmStandardCSN : public AcmStandardISO
{
public:
  ACRX_DECLARE_MEMBERS(AcmStandardCSN);

  AcmStandardCSN();
  virtual ~AcmStandardCSN();
  virtual LPCTSTR originalName() const;             
  virtual Adesk::Boolean acmInit();             
  virtual Acad::ErrorStatus dxfOutFields(AcDbDxfFiler* filer) const;             
  };                      

MAKE_ACDBOPENOBJECT_FUNCTION(AcmStandardCSN);


class STDIMP_DLLSHARE AcmSurfTextStdCSN : public AcmSurfTextStdISO
{
public:
  ACRX_DECLARE_MEMBERS(AcmSurfTextStdCSN);

  AcmSurfTextStdCSN();
  virtual ~AcmSurfTextStdCSN();
  
  virtual Acm::ErrorStatus initFields(AcmCSurfText* pData) const ;
  virtual Acm::ErrorStatus checkVisibility(AcmCSurfText* pData) const;
  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;
  virtual Adesk::Boolean   isCompatibleTo(const AcmStandard* pStd) const;
  virtual Adesk::Boolean   isCreatedFor(const AcmStandard* pStd) const;
  virtual void initToEditOriginal();
  virtual void initToEdit();
  virtual Acad::ErrorStatus dxfOutFields(AcDbDxfFiler* filer) const;
  virtual Acad::ErrorStatus getVarFromDlgIndex(Adesk::UInt8 dlgIndex, Acm::Variable& var) const;
  virtual AcmSurfTextStd::ConfigListState checkConfigListState(Acm::Variable var, CVarDlgInfo& varDlgInfo) const;
};                      

MAKE_ACDBOPENOBJECT_FUNCTION(AcmSurfTextStdCSN);


class STDIMP_DLLSHARE AcmFCFStdCSN : public AcmFCFStdISO
{
public:
  ACRX_DECLARE_MEMBERS(AcmFCFStdCSN);

  AcmFCFStdCSN();
  virtual ~AcmFCFStdCSN();

  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;
  virtual Adesk::Boolean   isCompatibleTo(const AcmStandard* pStd) const;
  virtual Adesk::Boolean   isCreatedFor(const AcmStandard* pStd) const;
  virtual Acad::ErrorStatus dxfOutFields(AcDbDxfFiler* filer) const;
  virtual Adesk::Boolean getMat(AcmCObjArray<AcmCGDTSymbolDesc>& list) const;
  virtual void getSubEnts(const AcmCFCF* pSymb,
                          AcmCAuxEntArray& subents, AcGePoint3d* pSecondLeaderPnt = NULL) const;
};                      

MAKE_ACDBOPENOBJECT_FUNCTION(AcmFCFStdCSN);


class STDIMP_DLLSHARE AcmWeldingStdCSN : public AcmWeldingStdISO
{
public:
  ACRX_DECLARE_MEMBERS(AcmWeldingStdCSN);

  AcmWeldingStdCSN();
  virtual ~AcmWeldingStdCSN();

  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;
  virtual Acm::ErrorStatus cInit();
  virtual Adesk::Boolean   isCompatibleTo(const AcmStandard* pStd) const;
  virtual Adesk::Boolean   isCreatedFor(const AcmStandard* pStd) const;
  virtual Acad::ErrorStatus dxfOutFields(AcDbDxfFiler* filer) const;
protected:
   virtual void getSideSubEnts(AcmCWeld* pWeld,
                              AcmCWeld* pWeldS,
                              AcmCAuxEntArray& entitySet,
                              Acm::AlignmentType& align,
                              double& moveX) const;

};                      

MAKE_ACDBOPENOBJECT_FUNCTION(AcmWeldingStdCSN);


class STDIMP_DLLSHARE AcmDatumStdCSN : public AcmDatumStdISO
{
public:
  ACRX_DECLARE_MEMBERS(AcmDatumStdCSN);

  AcmDatumStdCSN();
  virtual ~AcmDatumStdCSN();

  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;
  virtual Adesk::Boolean   isCompatibleTo(const AcmStandard* pStd) const;
  virtual Adesk::Boolean   isCreatedFor(const AcmStandard* pStd) const;
  virtual Acad::ErrorStatus dxfOutFields(AcDbDxfFiler* filer) const;
};                      

MAKE_ACDBOPENOBJECT_FUNCTION(AcmDatumStdCSN);


class STDIMP_DLLSHARE AcmIdStdCSN : public AcmIdStdISO
{
public:
  ACRX_DECLARE_MEMBERS(AcmIdStdCSN);
  
  AcmIdStdCSN();
  virtual ~AcmIdStdCSN();

  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;
  virtual Adesk::Boolean   isCompatibleTo(const AcmStandard* pStd) const;
  virtual Adesk::Boolean   isCreatedFor(const AcmStandard* pStd) const;
  virtual Acad::ErrorStatus dxfOutFields(AcDbDxfFiler* filer) const;
};

MAKE_ACDBOPENOBJECT_FUNCTION(AcmIdStdCSN);


class STDIMP_DLLSHARE AcmBOMStdCSN : public AcmBOMStdISO
{
public:
  ACRX_DECLARE_MEMBERS(AcmBOMStdCSN);

  AcmBOMStdCSN();
  virtual ~AcmBOMStdCSN();

  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;
  virtual Adesk::Boolean   isCompatibleTo(const AcmStandard* pStd) const;
  virtual Adesk::Boolean   isCreatedFor(const AcmStandard* pStd) const;
};

MAKE_ACDBOPENOBJECT_FUNCTION(AcmBOMStdCSN);

#endif // STDCSN


